/*
 * ar4c-dcdc - comm-posix.c
 *
 * Communication with host
 *
 * Copyright (C) 2014  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <compiler.h>
#include <comm.h>
#include <stdio.h>

#define NUM_REGS	16
#define DC_REGS_MASK	0x0f

int comm_regs[NUM_REGS];

void comm_reg_write(unsigned char reg, int value)
{
	printf("r[%d]: %d\n", reg, value);
	comm_regs[reg & DC_REGS_MASK] = value;
}

int comm_reg_read(unsigned char reg)
{
	return comm_regs[reg];
}

void comm_reg_clear(unsigned char reg, int value)
{
	comm_regs[reg & DC_REGS_MASK] &= ~value;
}

void comm_init(void)
{
}
