/*
 * ar4c-dcdc - comm.h
 *
 * Copyright (C) 2014  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

#ifndef COMM_H_INCLUDED
#define COMM_H_INCLUDED

#define COMM_FLAGS		0
#define COMM_VIN		1
#define COMM_VBAT		3
#define COMM_THROTTLE		5
#define COMM_Q			6
#define COMM_VIN_RAW		8
#define COMM_VBAT_RAW		9
#define COMM_COMMAND		0xf
#define COMM_SELFDISCHARGE	0x10
#define COMM_SCALER		0x1c
#define COMM_VERSION		0x1d
#define COMM_SERIAL		0x1e

#define DC_BAT_PRESENT		0x0001	/* Battery Present */
#define DC_BAT_CRITICAL		0x0002	/* Critical Battery Level */
#define DC_BAT_LOW		0x0004	/* Low Battery Level */
#define DC_BAT_GOOD		0x0008	/* Good Battery State */
#define DC_BAT_FAIL		0x0010	/* Battery Failure */
#define DC_BAT_CHARGING		0x0020	/* Battery Charging in Progress */
#define DC_BAT_DISCHARGING	0x0040	/* Battery Discharging */
#define DC_BAT_CHARGE_ERR	0x0080	/* Battery Charger Error */
#define DC_BAT_HIGH		0x0100	/* Battery Voltage Too High */
//#define DC_BAT_THROTTLE		0x0040	/* Battery Thermal Throttling */

#define DC_DC0_PRESENT		0x1000	/* DC0 Supply Voltage Present */
#define DC_DC0_LOW		0x2000	/* DC0 Supply Voltage too Low */
#define DC_DC0_HIGH		0x4000	/* DC0 Supply Voltage too High */
#define DC_SHUTDOWN		0x8000	/* Shutdown in progress */

#define DC_BAT_SHUTDOWN_CLEAR	(DC_BAT_CRITICAL | DC_BAT_LOW \
		| DC_BAT_DISCHARGING | DC_BAT_CHARGING | DC_BAT_GOOD)

#define DC_BAT_MASK		0x00ff


#define COMM_CMD_POWEROFF0	0x01
#define COMM_CMD_POWEROFF1	0x02
#define COMM_CMD_POWEROFF_ALL	(COMM_CMD_POWEROFF0 | COMM_CMD_POWEROFF1)

void comm_init(void);

void comm_reg_write(unsigned char reg, int value);
void comm_reg_clear(unsigned char reg, int value);
int comm_reg_read(unsigned char reg);

#endif
