/*
 * ar4c-dcdc - storage.c
 *
 * Copyright (C) 2014  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <storage.h>
#include <watchdog.h>
#include <ltypes.h>
#include <comm.h>

#define CONFIG_BASE		0x0000

#define CONFIG_COPIES	2

u16 config_read(unsigned char reg)
{
	unsigned int addr = CONFIG_BASE + 8 * reg;
	unsigned char i;
	u16 x;
	u16 csum;

	for (i = 0; i < CONFIG_COPIES; i++) {
		x = ee_read(addr++) << 8;
		x |= ee_read(addr++);
		csum = ee_read(addr++) << 8;
		csum |= ee_read(addr++);
		wdt_reset();
		if (csum == ~x)
			return x;
	}
	return 0;
}

void config_write(u16 x, unsigned char reg)
{
	unsigned int addr = CONFIG_BASE + 8 * reg;
	unsigned char i;
	u16 csum;

	csum = ~x;
	for (i = 0; i < CONFIG_COPIES; i++) {
		ee_write(x >> 8, addr++);
		ee_write(x & 0xff, addr++);
		ee_write(csum >> 8, addr++);
		ee_write(csum & 0xff, addr++);
		wdt_reset();
	}
}
